/* Problem URL: https://codeforces.com/contest/2106/problem/D */

#include <bits/stdc++.h>

using namespace std;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (size_t i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (size_t i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
    cin >> t;
    while (t--) {
        int n, m;
        cin >> n >> m;

        vl a(n);
        cin >> a;
        vl b(m);
        cin >> b;
        b.push_back(0);

        vi pref(m, -1);
        vi suf(m, -1);

        int now = 0;
        for (int i = 0; i < n && now < m; i++) {
            if (a[i] >= b[now]) {
                pref[now] = i;
                now++;
            }
        }

        now = m - 1;
        for (int i = n - 1; i >= 0 && now >= 0; i--) {
            if (a[i] >= b[now]) {
                suf[now] = i;
                now--;
            }
        }

        ll ans = INT64_MAX >> 1;

        if (pref.back() != -1) {
            cout << "0\n";
            continue;
        }

        if (m == 1) {
            cout << b[0] << '\n';
            continue;
        }

        if (pref[m - 1] == -1 && pref[m - 2] != -1) {
            rmin(ans, b[m - 1]);
        }
        
        if (suf[1] != -1 && suf[0] == -1) {
            rmin(ans, b[0]);
        }

        for (int i = 1; i < m - 1; i++) {
            if (pref[i - 1] != -1 && suf[i + 1] != -1 && pref[i - 1] < suf[i + 1]) {
                rmin(ans, b[i]);
            }
        }

        cout << (ans == INT64_MAX >> 1 ? -1 : ans) << '\n';
    }
}
